const Gdk = imports.gi.Gdk;

/*

GDK Color is stored as a RGB string "nnnnn,nnnnn,nnnnn"
Where nnnnn is 00000 - 65535

CSS Color is returned as a RGB string "N,N,N"
Where N is 0 - 255

*/

function scaleColorCSS(value) {
    value = Math.floor((value / 255) + 0.5);
    value = Math.max(value, 0);
    value = Math.min(value, 255);
    return value;
}

function getColorGDKandCSS(colorString) {
    let redValue = parseInt(colorString.slice(0,5));
    let red = scaleColorCSS(redValue);
    let greenValue = parseInt(colorString.slice(6,11));
    let green = scaleColorCSS(greenValue);
    let blueValue = parseInt(colorString.slice(12));
    let blue = scaleColorCSS(blueValue);
    let color = new Gdk.Color({red: redValue, green: greenValue, blue: blueValue});
    return {'gdk': color, 'red': red, 'green': green, 'blue': blue};
}

function formatColor(value) {
    let str = value.toString();
    while (str.length < 5)
	str = '0' + str;
    return str;
}

function getColorString(color) {
    return formatColor(color.red) + ',' + formatColor(color.green) + ',' + formatColor(color.blue);
}

function getColorStringCSS(color) {
    return color['red'].toString() + ',' + color['green'].toString() + ',' + color['blue'].toString();
}
